#include "stdafx.h"
#include "dialog.h"
#include "resource.h"
#include "commctrl.h"




INT_PTR CALLBACK DlgProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		{
			// Initialise configuration dialog
			SendDlgItemMessage(hWnd,IDC_SPIN,UDM_SETRANGE,0,MAKELONG(5000,1));

			CHAR c[100];
			sprintf(&c[0],"%d",FrameRate);
			SendDlgItemMessage(hWnd,IDC_FRAMERATE,CB_ADDSTRING,0,(LPARAM)"100");
			SendDlgItemMessage(hWnd,IDC_FRAMERATE,CB_ADDSTRING,0,(LPARAM)"200");
			SendDlgItemMessage(hWnd,IDC_FRAMERATE,CB_ADDSTRING,0,(LPARAM)"500");
			SendDlgItemMessage(hWnd,IDC_FRAMERATE,CB_ADDSTRING,0,(LPARAM)"1000");
			SendDlgItemMessage(hWnd,IDC_FRAMERATE,CB_ADDSTRING,0,(LPARAM)"2000");

			SendDlgItemMessage(hWnd,IDC_FRAMERATE,CB_SELECTSTRING,0,(LPARAM)&c[0]);
			SetDlgItemText(hWnd,IDC_FRAMERATE,&c[0]);

			SendDlgItemMessage(hWnd,IDC_AUTOFRAMERATE,BM_SETCHECK,UseAutoFrameRate,0);
			SendDlgItemMessage(hWnd,(EncodeOption==0)?IDC_CODECOPTION:(EncodeOption==1)?IDC_RADIO2:IDC_RADIO3,BM_SETCHECK,1,0);
		}
		break;
	case WM_CLOSE:EndDialog(hWnd,0);
		break;
	case WM_COMMAND:
		if (wParam==IDC_MAIL)
		{
			ShellExecute(hWnd,"open","mailto:mail@saschahlusiak.de",NULL,NULL,SW_SHOW);
		}
		if (wParam==IDC_HP)
		{
			ShellExecute(hWnd,"open","http://www.saschahlusiak.de",NULL,NULL,SW_SHOW);
		}
		if (wParam==IDOK)
		{
			CHAR c[100];
			GetDlgItemText(hWnd,IDC_FRAMERATE,&c[0],100);
			int i=atoi(&c[0]);
			if (i==0)MessageBox(hWnd,"Invalid framerate. Enter a valid framerate or pick one from the list.","Try again, looser.",MB_OK|MB_ICONEXCLAMATION);
			else {
				int j;
				if (SendDlgItemMessage(hWnd,IDC_CODECOPTION,BM_GETCHECK,0,0)) j=0;
				if (SendDlgItemMessage(hWnd,IDC_RADIO2,BM_GETCHECK,0,0)) j=1;
				if (SendDlgItemMessage(hWnd,IDC_RADIO3,BM_GETCHECK,0,0)) j=2;

				EncodeOption=j;
				FrameRate=i;
				UseAutoFrameRate=(BOOLEAN)SendDlgItemMessage(hWnd,IDC_AUTOFRAMERATE,BM_GETCHECK,0,0);
				EndDialog(hWnd,1);
			}
		}
		if (wParam==IDCANCEL)EndDialog(hWnd,0);
		break;
	default:return NULL;
	}
	return NULL;
}

void RunConfigDialog(HWND Parent,HINSTANCE DllInstance)
{
	// Opends the configuration dialog
	DialogBox(DllInstance,MAKEINTRESOURCE(IDD_CONFIG),Parent,DlgProc);
}