#include "stdafx.h"
#include "gifwcx.h"


inline int FileTime(int year,int month,int day,int hour,int minute,int second)
{
	return (((year - 1980) << 25) | (month << 21) | (day << 16) | (hour << 11) | (minute << 5) | (second/2));
}


CGifRead::CGifRead()
{
	ArcName=NULL;
}

CGifRead::~CGifRead()
{
	if (ArcName)free(ArcName);
	ArcName=NULL;
}

BOOLEAN CGifRead::Load(PCHAR filename)
{
	if (!Image.Load(filename, CXIMAGE_FORMAT_GIF))return FALSE;
	ArcName=(char*)malloc(strlen(filename)+2);
	strcpy(ArcName,filename);

	index=0;

	// Get file time
	SYSTEMTIME time;
	FILETIME local;
	FileTimeToLocalFileTime(&attr.ftLastWriteTime,&local);
	FileTimeToSystemTime(&local,&time);
	filetime=FileTime(time.wYear,time.wMonth,time.wDay,time.wHour,time.wMinute,time.wSecond);

	// Attributes
	GetFileAttributesEx(filename,GetFileExInfoStandard,&attr);

	// Determinate the name format of the frame files
	NumFrames=Image.GetNumFrames();
	digits=(int)ceil(log10f((float)(NumFrames+1)));
	sprintf(&frameformatname[0],"Frame%%0.%dd.%%s",digits);

	return TRUE;
}

BOOLEAN CGifRead::ReadHeader(tHeaderData *HeaderData)
{
	// Returns the header of the file
	if (index>=Image.GetNumFrames())return E_END_ARCHIVE;


	{	// Return Frame file
		strcpy(HeaderData->ArcName,ArcName);

		sprintf(&HeaderData->FileName[0],frameformatname,index,"gif");

		HeaderData->FileAttr=FILE_ATTRIBUTE_ARCHIVE;
		HeaderData->FileCRC=0;

		HeaderData->FileTime=filetime;

		HeaderData->PackSize=attr.nFileSizeLow/NumFrames;
		HeaderData->UnpSize=attr.nFileSizeLow/NumFrames;
	}

	return 0;
}


BOOLEAN CGifRead::ProcessFile(int Operation, char *DestPath, char *DestName)
{
	if (Operation==PK_EXTRACT)
	{
		static CHAR path[MAX_PATH];
		if (DestPath==NULL)strcpy(&path[0],DestName);
		else {
			strcpy(&path[0],DestPath);
			strcat(&path[0],DestName);
		}

		if (!ReadFrame(&Image,index))return E_EREAD;
		if (!Image.Save(&path[0],CXIMAGE_FORMAT_GIF))return E_EWRITE;

		// ProcessDataProc
		if (ProcessDataProc(DestName,attr.nFileSizeLow/NumFrames)==0)
		{
			index++;
			return E_EABORTED;	
		}
	}

	index++;

	return 0;
}

BOOLEAN CGifRead::ReadFrame(CxImage *img,int i)
{
	img->SetFrame(i);
	img->Load(ArcName,CXIMAGE_FORMAT_GIF);
	if (!img->IsValid())return FALSE;

	// Doing strange things:
	// Sometimes the TransIndex is 0, but it should be -1
//	if (img->GetTransIndex()==0)img->SetTransIndex(-1);

	return TRUE;
}