#include "stdafx.h"
#include "dialog.h"
#include "gifwcx.h"
#include "cximage/cximage/xiofile.h"


HINSTANCE hInstance;
BOOLEAN UseAutoFrameRate=TRUE;
int FrameRate=1000,EncodeOption=2;


HANDLE __stdcall MyOpenArchive (tOpenArchiveData *ArchiveData);
int __stdcall MyReadHeader (HANDLE hArcData, tHeaderData *HeaderData);
int __stdcall MyProcessFile (HANDLE hArcData, int Operation, char *DestPath, char *DestName);
int __stdcall MyCloseArchive (HANDLE hArcData);
void __stdcall SetChangeVolProc (HANDLE hArcData, tChangeVolProc pChangeVolProc1);
void __stdcall SetProcessDataProc (HANDLE hArcData, tProcessDataProc pProcessDataProc);
int __stdcall GetPackerCaps();
void __stdcall ConfigurePacker (HWND Parent, HINSTANCE DllInstance);
int __stdcall PackFiles (char *PackedFile, char *SubPath, char *SrcPath, char *AddList, int Flags);
int __stdcall DeleteFiles (char *PackedFile, char *DeleteList);




tProcessDataProc gProcessDataProc; 



BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	// Save HINSTANCE value 
	hInstance=(HINSTANCE)hModule;
    return TRUE;
}



HANDLE _stdcall MyOpenArchive(tOpenArchiveData *ArchiveData)
{
	// Opens a file for reading
	PGifRead file=new CGifRead;

	if (!file->Load(ArchiveData->ArcName))
	{
		delete file;
		ArchiveData->OpenResult=E_BAD_ARCHIVE;
		return 0;
	}
	return file;
}

int __stdcall MyCloseArchive(HANDLE hArcData)
{
	// Closes a file
	delete ((PGifRead)(hArcData));
	return 0;
}

int __stdcall MyReadHeader(HANDLE hArcData,tHeaderData *HeaderData)
{
	// Reads header
	return ((PGifRead)(hArcData))->ReadHeader(HeaderData);
}

int __stdcall MyProcessFile (HANDLE hArcData, int Operation, char *DestPath, char *DestName)
{
	// Extract a frame from file
	return ((PGifRead)(hArcData))->ProcessFile(Operation,DestPath,DestName);
}

void __stdcall SetChangeVolProc (HANDLE hArcData, tChangeVolProc pChangeVolProc1)
{
}

void __stdcall MySetProcessDataProc (HANDLE hArcData, tProcessDataProc pProcessDataProc)
{
	// Set local or global callback proc for ProcessData
	if (hArcData==INVALID_HANDLE_VALUE || hArcData==(HANDLE)0xffffffff)
	{
		gProcessDataProc=pProcessDataProc;
		return;
	}
	((PGifRead)(hArcData))->SetProcessDataProc(pProcessDataProc);
}

int __stdcall GetPackerCaps()
{
	// Accept New file, Options dialog, Multiple files, hide (press CTRL+Down to enter file for reading), Modify (add files) and deleting
	return PK_CAPS_MULTIPLE|PK_CAPS_OPTIONS|PK_CAPS_NEW|PK_CAPS_HIDE|PK_CAPS_MODIFY|PK_CAPS_DELETE;
}

void __stdcall ConfigurePacker (HWND Parent, HINSTANCE DllInstance)
{
	// Configure packer options (framerate, etc)
	RunConfigDialog(Parent,DllInstance);
}

int __stdcall PackFiles (char *PackedFile, char *SubPath, char *SrcPath, char *AddList, int Flags)
{
	// Encode a set of files to a file
	PCHAR file=AddList;

	// First count numbers of files for packing
	int NumFrames=0;
	do
	{
		while (*(file++)!='\0');
		NumFrames++;
	}while (*(file)!='\0');

	// We may add files to an existing gif file. Check if we do so.
	CGifRead *gif=new CGifRead;
	if (!gif->Load(PackedFile))
	{ delete gif; gif=NULL; }else
	{
		NumFrames+=gif->NumFrames;
	}


	// Create CxImage Array
	int i=0;
	CxImage **Images=new CxImage*[NumFrames];
	CxImage *Image;
	CxIOFile f;

	for (i=0;i<NumFrames;i++)Images[i]=NULL;

	// Get all existing frames of the existing gif file
	if (gif)
	{
		for (i=0;i<gif->NumFrames;i++)
		{
			Images[i]=new CxImage;
			if (!gif->ReadFrame(Images[i],i))goto error;
			Images[i]->SetCodecOption(EncodeOption);
		}
	}

	// Load Image files
	file=AddList;
	i=gif?gif->NumFrames:0;
	do
	{
		static CHAR path[MAX_PATH];
		Images[i]=new CxImage;

		strcpy(&path[0],SrcPath);
		strcat(&path[0],file);
		Images[i]->SetDisposalMethod(2); /* Restore to background color */
		if (Images[i]->Load(&path[0],CXIMAGE_FORMAT_GIF)==FALSE)goto error;
		Images[i]->SetDisposalMethod(2); /* Restore to background color */

		if (Images[i]->GetBpp()>8)Images[i]->DecreaseBpp(8,TRUE);	// Make indexed image
		
		if (Images[i]->AlphaIsValid())	
			// If this is an image with alpha channel (like png), try to make the gif transparent, too
		{
			CxImage alpha;
			Images[i]->AlphaSplit(&alpha);
			Images[i]->AlphaDelete();

			RGBQUAD pc=alpha.GetPixelColor(0,0);
			if (pc.rgbBlue+pc.rgbGreen+pc.rgbRed==0) // Transparent (or very odd) pixel found
			{
				BYTE ind=Images[i]->GetPixelIndex(0,0);
				Images[i]->SetTransIndex(ind);
			}
		}

		if ((Images[i]->GetFrameDelay()<=0)||(!UseAutoFrameRate))
			Images[i]->SetFrameDelay(FrameRate/10);
		Images[i]->SetCodecOption(EncodeOption);

		while (*(file++)!='\0');
		i++;


		{	// Receive File-Size
			DWORD filesize;
			HANDLE h=CreateFile(&path[0],GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,0,0);
			if (h==INVALID_HANDLE_VALUE)filesize=0;
				else filesize=GetFileSize(h,NULL);
			CloseHandle(h);
			if (gProcessDataProc(file,filesize)==0)
			{
				if (Images)for (int i=0;i<NumFrames;i++)if (Images[i])delete Images[i];
				delete[] Images;
				return E_EABORTED;
			}
		}
	}while (*(file)!='\0');

	// Save Image
	if (!f.Open(PackedFile,"w+b"))goto error;

	Image=new CxImage(CXIMAGE_FORMAT_GIF);
	Image->SetDisposalMethod(2); /* Restore to background color */
	if (!Image->Encode(&f,&Images[0],NumFrames,CXIMAGE_FORMAT_GIF))goto error;
	
	delete Image;
	f.Close();

	// Clean up
	if (Images)for (int i=0;i<NumFrames;i++)if (Images[i])delete Images[i];
	delete[] Images;
	if (gif) delete gif;
	return 0;

error:
	// Error & Clean up
	if (Images)for (int i=0;i<NumFrames;i++)if (Images[i])delete Images[i];
	delete[] Images;
	if (gif)delete gif;
	return E_EREAD;
}

int __stdcall DeleteFiles (char *PackedFile, char *DeleteList)
{
#define RETERROR(ret) { for (i=0;i<gif.NumFrames;i++)delete Images[i]; delete[] Images; return ret; }
	CGifRead gif;
	int i;
	if (!gif.Load(PackedFile))return E_EREAD;

	CxImage **Images=new CxImage*[gif.NumFrames];

	// Load all gif frames
	BOOLEAN b=TRUE;
	for (int i=0;i<gif.NumFrames;i++)
	{
		Images[i]=new CxImage;

		b&=gif.ReadFrame(Images[i],i);
		int c=gif.Image.GetCodecOption();
		Images[i]->SetCodecOption(c);
	}
	if (!b) RETERROR(E_EREAD);

	// Sort the array and put the deleting frames to the end
	int FramesRemaining=gif.NumFrames;
	PCHAR file=DeleteList;
	do
	{
		// Very ::ugly:: code, We get names like 'Frame123.gif'
		// It converts the string from the 6th char to an int, here 123.gif, which results in 123
		// ButIt works, So be happy!
		if (strlen(file)<=6)RETERROR(E_EREAD);
		int num=atoi(&file[5]);	
		if ((num==0)&&(file[5]!='0'))RETERROR(E_EREAD);

		// Perform a very fast rearangement of the Images
		CxImage* r=Images[num];
		for (i=num;i<gif.NumFrames-1;i++)Images[i]=Images[i+1];
		Images[gif.NumFrames-1]=r;

		FramesRemaining--;

		while (*(file++)!='\0');
	}while (*(file)!='\0');

	if (FramesRemaining<1)RETERROR(E_NO_FILES);

	// Reencode the remaining frames
	CxImage Image;
	CxIOFile f;
	if (!f.Open(PackedFile,"w+b"))RETERROR(E_ECREATE);
	if (!Image.Encode(&f,&Images[0],FramesRemaining,CXIMAGE_FORMAT_GIF))RETERROR(E_ECREATE);

	// All went fine. Clean up and return
	for (i=0;i<gif.NumFrames;i++)delete Images[i];
	delete[] Images;

	return 0;
}


